/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_CAMERAH265IMAGE_H
#define IMPL_TYPE_CAMERAH265IMAGE_H

#include "impl_type_int32.h"
#include "impl_type_int8.h"
#include "impl_type_vectoruint8.h"
#include "impl_type_driverheader.h"
#include "impl_type_boolean.h"

struct CameraH265Image {
    ::Int32 dataSize{ 0 };
    ::Int8 cameraId{ 0 };
    ::VectorUInt8 rawData;
    ::DriverHeader header;
    ::Boolean gopFlag{ false };

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(dataSize);
        fun(cameraId);
        fun(rawData);
        fun(header);
        fun(gopFlag);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(dataSize);
        fun(cameraId);
        fun(rawData);
        fun(header);
        fun(gopFlag);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("dataSize", dataSize);
        fun("cameraId", cameraId);
        fun("rawData", rawData);
        fun("header", header);
        fun("gopFlag", gopFlag);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("dataSize", dataSize);
        fun("cameraId", cameraId);
        fun("rawData", rawData);
        fun("header", header);
        fun("gopFlag", gopFlag);
    }

    friend bool operator==(const ::CameraH265Image& lhs, const ::CameraH265Image& rhs) noexcept
    {
        return (lhs.dataSize == rhs.dataSize) && (lhs.cameraId == rhs.cameraId) && (lhs.rawData == rhs.rawData) && (lhs.header == rhs.header) && (lhs.gopFlag == rhs.gopFlag);
    }
};


#endif // IMPL_TYPE_CAMERAH265IMAGE_H
